import es
import playerlib
import soccer.soccer as soccerlib
import psyco
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Goalie Script"
info.version = soccerlib.info.version
info.basename = "soccergoalie"
info.author = "chrismrulz"

soccerteamskins_enabled = int(soccerlib.config.get("Core", "soccerteamskins_enabled"))
tgskin = soccerlib.config.get("Goalie", "tgskin")
ctgskin = soccerlib.config.get("Goalie", "ctgskin")
tskin = soccerlib.config.get("Skins", "tskin")
ctskin = soccerlib.config.get("Skins", "ctskin")
soccerlib.adddownloads([tgskin,ctgskin,tskin,ctskin])
goalxm = soccerlib.goalxm
goalxp = soccerlib.goalxp
tgoalym = soccerlib.tgoalym
tgoalyp = soccerlib.tgoalyp
ctgoalym = soccerlib.ctgoalym
ctgoalyp = soccerlib.ctgoalyp
tgoalie = 0
thetgoalie = -1
ctgoalie = 0
thectgoalie = -1

def load():
	es.msg('#Green','Soccer Goalie Script On - by Toph')
	resetglobals()
	soccerlib.hook(goalbox1, 'goalbox1')
	soccerlib.hook(goalbox2, 'goalbox2')
	soccerlib.hook(thefield, 'thefield')

def unload():
	es.msg('#Green','Soccer Goalie Script Off')

def es_map_start(event_var):
	resetglobals()

def resetglobals():
	resett()
	resetct()

def resett():
	global tgoalie
	global thetgoalie
	tgoalie = 0
	thetgoalie = -1

def resetct():
	global ctgoalie
	global thectgoalie
	ctgoalie = 0
	thectgoalie = -1

def round_start(event_var):
	resetglobals()

def goalbox1(userid):
	global tgoalie
	global thetgoalie
	if(tgoalie == 0):
		if(thetgoalie != userid):
			global soccerteamskins_enabled
			if(soccerteamskins_enabled == 1):
				es.doblock('soccer/soccerteamskins/lo3spawn')
			elif(thetgoalie != -1):
				playerlib.getPlayer(thetgoalie).setModel(tskin)
			tgoalie = 1
			thetgoalie = userid
			playerlib.getPlayer(userid).setModel(tgskin)
		else:
			tgoalie = 1
	es.set('thetgoalie', thetgoalie)

def goalbox2(userid):
	global ctgoalie
	global thectgoalie
	if(ctgoalie == 0):
		if(thectgoalie != userid):
			global soccerteamskins_enabled
			if(soccerteamskins_enabled == 1):
				es.doblock('soccer/soccerteamskins/lo3spawn')
			elif(thetgoalie != -1):
				playerlib.getPlayer(thectgoalie).setModel(ctskin)
			ctgoalie = 1
			thectgoalie = userid
			playerlib.getPlayer(userid).setModel(ctgskin)
		else:
			ctgoalie = 1
	es.set('thectgoalie', thectgoalie)

def thefield(userid):
	crteam = es.getplayerteam(userid)
	if(crteam == 2):
		global thetgoalie
		if(thetgoalie == userid):
			crdeathx = playerlib.getPlayer(userid).x
			crdeathy = playerlib.getPlayer(userid).y
			if(crdeathx < goalxp and crdeathy < tgoalyp and crdeathx > goalxm and crdeathy > tgoalym):
				pass
			else:
				global tgoalie
				tgoalie = 0
	elif(crteam == 3):
		global thectgoalie
		if(thectgoalie == userid):
			crdeathx = playerlib.getPlayer(userid).x
			crdeathy = playerlib.getPlayer(userid).y
			if(crdeathx < goalxp and crdeathy < ctgoalyp and crdeathx > goalxm and crdeathy > ctgoalym):
				pass
			else:
				global ctgoalie
				ctgoalie = 0

def player_hurt(event_var):
	if(event_var['weapon'] == "knife"):
		userid = event_var['userid']
		if(userid == thetgoalie):
			kgkx,kgky,kgkz = es.getplayerlocation(userid)
			if(kgkx < goalxp and kgky < tgoalyp and kgkx > goalxm and kgky > tgoalym):
				es.msg('#multi', "#greenPlayer#lightgreen %s #greenknifed the terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))
		elif(userid == thectgoalie):
			kgkx,kgky,kgkz = es.getplayerlocation(userid)
			if(kgkx < goalxp and kgky < ctgoalyp and kgkx > goalxm and kgky > ctgoalym):
				es.msg('#multi',"#greenPlayer#lightgreen %s #greenknifed the counter-terrorist team keeper:#lightgreen %s" % (event_var['es_attackername'], event_var['es_username']))

def activecheck(userid):
	if(userid == thetgoalie):
		resett()
	elif(userid == thectgoalie):
		resetct()

def player_disconnect(event_var):
	activecheck(event_var['userid'])

def player_death(event_var):
	activecheck(event_var['userid'])

def player_spawn(event_var):
	if(soccerteamskins_enabled != 1):
		if(event_var['es_userteam'] == '2'):
			playerlib.getPlayer(event_var['userid']).setModel(tskin)
		elif(event_var['es_userteam'] == '3'):
			playerlib.getPlayer(event_var['userid']).setModel(ctskin)